/* Servidor de ficheros, por Paco Brufal, (c)1999
 *
 * Parte cliente.
 */

#include "fileserv.h"
 
int main(int argc, char *argv[]) {
    struct sockaddr_in sin;
    int sock; 
  
    if(argc < 2 || argc > 3) {
        printf("Cliente de ficheros %s, (c)Paco Brufal 1999.\n",version);
        printf("Uso: ./%s <host> <fichero>\n",argv[0]);
        printf("<host>      Host del servidor de ficheros. Vale tanto el nombre como la IP.\n");
        printf("<fichero>   Nombre del fichero o \"lista\" para ver un listado.\n");
        exit(1);
    }
    hp = gethostbyname(argv[1]);
    if (hp==NULL) {
        printf("No se puede conectar con %s\n",argv[1]);
        exit(1);
    }
    bzero((char*) &sin, sizeof(sin));
    bcopy(hp->h_addr, (char *) &sin.sin_addr, hp->h_length);
    sin.sin_family = hp->h_addrtype;
    sin.sin_port = htons(PUERTO);
    sock = socket(AF_INET, SOCK_STREAM, 0);
    if((connect(sock,(struct sockaddr *) &sin, sizeof(sin))) < 0) {
        printf("Hubo un error en la conexin con el host %s.\n",argv[1]);
        exit(1);
    }
    buffer = (char *)malloc(1000000);
    memset(buffer,0,sizeof(buffer));
    if(write(sock,argv[2],strlen(argv[2]))<0) {
          printf("Error enviando.\n");
          perror("write");
          close(sock);
          free(buffer);
          exit(1);
    }
    fprintf(stderr,"\nCliente de ficheros %s. (c)Paco Brufal, 1999.\n",version);
    fprintf(stderr,"Servidor de horario: %s\n", argv[1]);
    fprintf(stderr,"Peticin enviada: %s\n",argv[2]);
    fprintf(stderr,"Resultado de la peticin:\n");
    fprintf(stderr,"-------------------------\n\n");
    memset(buffer,0,strlen(buffer));
    while(read(sock,buffer,1)>0) {
        printf("%s",buffer);
//        memset(buffer,0,strlen(buffer));
    }
    close(sock);
    free(buffer);
    return 0;
}
