/* Servidor de ficheros, (c)Paco Brufal 1999
 *
 * Parte servidor.
 */
 
#include "fileserv.h"

char *home;
char error[4096];
FILE *rc, *textos;
char dir_ficheros[512];
static char* fileservrc="/.fileservrc";

void enviar(int nuevo_sock, char *fichero);
void listado(int nuevo_sock);
void test_rc(void);

int main() {

  struct sockaddr_in dire;
  struct sockaddr_in my_addr;
  struct sockaddr* sock_serv;
  struct in_addr *laip;
  struct flock fl;
  int sock_des, nuevo_sock, tam, fd;
  char mi_ip2[256];
  char log[4096];

  signal (SIGCHLD, SIG_IGN);

  test_rc();

  if ((sock_des = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
    perror("socket");
    exit(1);
  }

  sock_serv = ( struct sockaddr* ) &my_addr;
  my_addr.sin_family = AF_INET;
  my_addr.sin_port = htons(PUERTO);
  my_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  bzero(&(my_addr.sin_zero), 8);
    
  if(bind(sock_des,sock_serv,sizeof(my_addr))<0) {
    perror("bind");
    exit(1);
  } 
  if (listen(sock_des, MAX) == -1) {
    perror("listen");
    exit(1);
  } 
  printf("Servidor de ficheros %s, (c)Paco Brufal 1999\n", version);
  printf("Mximo conexiones simultaneas: %d\n\n",MAX);

/*  gethostname(mi_ip2,256);
  mi_hp=gethostbyname(mi_ip2);
  laip=(struct in_addr*) mi_hp->h_addr;
  printf("IP Local: %s",inet_ntoa(*laip)); */

  while(1) {
    tam = sizeof(struct sockaddr_in);
    if((nuevo_sock = accept(sock_des, (struct sockaddr *)&dire, &tam))==-1) {
      perror("accept");
      exit(1);
    }
    if (!fork()) {
      buffer=(char *)malloc(1000);
      memset(buffer,0,strlen(buffer));
      read(nuevo_sock,buffer,100);

      hp = gethostbyname(inet_ntoa(dire.sin_addr));
              
      time(&fecha);
      fecha=time(NULL);
      date_total=localtime(&fecha);
      sprintf(log,"[%d/%d/%d - %d:%d:%d] Peticin de %s: %s  ",
             date_total->tm_mday,date_total->tm_mon+1,date_total->tm_year+1900,
             date_total->tm_hour,date_total->tm_min,date_total->tm_sec,hp->h_name,buffer);

      if(!strncmp(buffer,"lista",5)) {
        listado(nuevo_sock);
        free(buffer);
        close(nuevo_sock);
        exit(0);
      }
      enviar(nuevo_sock,buffer);
      printf("error: %s\n",error);
      printf("log: %s\n",log);
      strcat(log,error);

  fl.l_pid = getpid();
  fl.l_type = F_WRLCK;
  fl.l_whence = SEEK_SET;
  fl.l_start= 0;
  fl.l_len = 0;

  if ((fd = open("fileserver.log", O_WRONLY)) == -1) {
    perror("open");
    exit(1);
  }

  fcntl(fd, F_SETLKW, &fl);
  lseek(fd,0,SEEK_END);
  write(fd,log,strlen(log));
  fl.l_type = F_UNLCK;
  fcntl(fd, F_SETLK, &fl);
  close(fd);
        
      free(buffer);
      close(nuevo_sock);
      // error[0]='\0';
      exit(0);
    }
    close(nuevo_sock);
    while(waitpid(-1,NULL,WNOHANG) > 0);
  }
  return 0;
}

void enviar(int nuevo_sock, char *fichero) {
    FILE *file;
    char mio[256];
    char temp[1024];

    if(!strncmp(".",fichero,1)) {
        send(nuevo_sock,"No vale hacer trampas ;)\n",25,0);
        strcpy(error,"Intento de hackeo X'DDD\n");
    }
    
    strcat(dir_ficheros,fichero);
    if((file=fopen(dir_ficheros,"rt"))==NULL) {
        sprintf(temp,"\nError enviando fichero %s\n", dir_ficheros);
        strcpy(error,temp);
    }
    memset(mio,0,sizeof(mio));
    while(!feof(file)) {
        if(fgets(mio,256,file)==NULL) break;
        send(nuevo_sock,mio,strlen(mio),0);
    }
    fclose(file);
    strcpy(error,"OK\n");
}

void listado(int nuevo_sock) {
    struct dirent **namelist;
    char nombre[255];
    int n=2;

    n = scandir(dir_ficheros, &namelist, 0, alphasort);
    if (n < 0)
        perror("scandir");
    else {
        while(-((--n)-1)) {
            sprintf(nombre,"%s\n",namelist[n]->d_name);
            send(nuevo_sock, nombre,strlen(nombre),0);
        }
        printf("OK\n");
    }
}

void test_rc(void) {
    
    home=getenv("HOME");
    strcat(home,fileservrc);    
    if((rc=fopen(home,"rt"))==NULL) {
        printf("Error: Falta o no se puede abrir el fichero %s\n",home);
        printf("Crea un fichero %s/.fileservrc, y escribe el\n",home);
        printf("directorio donde se encuentran los ficheros de texto.\n");
        exit(1);
    }
    textos=fopen(home,"rt");
    fgets(dir_ficheros,511,textos);
    strcpy(&dir_ficheros[strlen(dir_ficheros)-1],"\0");
    fclose(textos);
}
